/*
 *  PeaGnut - Command-line Gnutella client for Unix
 *  Copyright (C) 2000  Ciaran Lynch
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <errno.h>

#include "completeio.h"
#include "log.h"

int read_all(int fd,void *buf,size_t count)
{
	int ret_val=0,bytes_read=0;
	
	while((ret_val!=-1)&&(bytes_read!=count))
	{
		ret_val=read(fd,buf,count-bytes_read);
		if(ret_val>=0)
		{
			bytes_read+=ret_val;
			((char *)buf)+=ret_val;
		}
		if((ret_val==-1)&&(errno==EINTR)) ret_val=0;
		if((ret_val==-1)&&(errno==EAGAIN)) ret_val=0;
		/*{
			log(LOG_INFO,"Would block ... %m");
		}*/
		else if(ret_val==0) return 0;
	}

	if(ret_val==-1) return -1;
	else return bytes_read;
}

int write_all(int fd,void *buf,size_t count)
{
	int ret_val=0,bytes_read=0;

	while((ret_val!=-1)&&(bytes_read!=count))
	{
		ret_val=write(fd,buf,count-bytes_read);
		if(ret_val>=0)
		{
			bytes_read+=ret_val;
			((char *)buf)+=ret_val;
		}
		if((ret_val==-1)&&(errno==EINTR)) ret_val=0;
		if((ret_val==-1)&&(errno==EAGAIN)) ret_val=0;
		if((ret_val==-1)&&(errno==EPIPE)) return 0;
	}

	if(ret_val==-1) return -1;
	else return bytes_read;
}

