/*
 *  PeaGnut - Command-line Gnutella client for Unix
 *  Copyright (C) 2000  Ciaran Lynch
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _CONNECTIONLIST_H
#define _CONNECTIONLIST_H

typedef struct {
	int complete; /* = Size read so far or -1 if complete */
	int payload_length;
	void *payload_buffer;
	unsigned char guid[16];
	unsigned char type;
	unsigned char ttl;
	unsigned char hops;
} packet_type;

typedef struct {
	char *address;
	char *port;
	int con_socket;
	int status;
	int num_packets; /* Number of partial packets in queue */
	packet_type *packet; /* Partial and full packets */
	char *response_buffer;
	int response_size;
} list_type;

int connection_list_add(char *address,char *port,int status,int con_socket);
int connection_list_remove(int index);
int connection_list_update_status(int index,int status);
int connection_list_free(void);
int connection_list_size(void);
int connection_list_write_challenge(int index);
int connection_list_write_response(int index);
int connection_list_check_challenge(int index);
int connection_list_check_response(int index);
list_type *connection_list(int index);

#endif
