/*
 *  PeaGnut - Command-line Gnutella client for Unix
 *  Copyright (C) 2000  Ciaran Lynch
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _LOG_H
#define _LOG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*
 * For now this is just a straight mapping to syslog
 */

int log_open(void);
int log(int priority,char *format,...);
int log_close(void);

#ifdef USE_SYSLOG
#include <syslog.h>
#else
#ifndef LOG_NOTICE
#define LOG_NOTICE 5 /* From Linux sys/syslog.h, value doesn't really matter */
#endif
#ifndef LOG_ERR
#define LOG_ERR 4
#endif
#ifndef LOG_INFO
#define LOG_INFO 6
#endif
#endif

#endif
